#ifndef __SCE_CRYPTO_H_
#define __SCE_CRYPTO_H_

enum SCE_ALGO_TYPE { SCE_HASH = 0, SCE_SCA = 1, SCE_TRNG = 2 };

enum TRNG_MODE {
	TRNG_RNP = 0,
	TRNG_SM4 = 1,
};

enum SCE_HASH_ALGO_TYPE {
	SCE_SHA1 = 0,
	SCE_SHA224 = 1,
	SCE_SHA256 = 2,
	SCE_SHA384 = 3,
	SCE_SHA512 = 4,
	SCE_MD5 = 5,
	SCE_SM3 = 8,
};

enum SCE_HASH_ALGO_MODE {
	SCE_NORMAL = 0,
	SCE_HMAC = 1,
};

enum SCE_SCA_ALGO_TYPE {
	SCE_AES_128 = 0x00,
	SCE_AES_192 = 0x10,
	SCE_AES_256 = 0x20,
	SCE_DES = 0x1,
	SCE_TDES = 0x2,
	SCE_SM4 = 0x4,
};

enum SCE_SCA_ALGO_MODE {
	ECB = 0,
	CTR = 1,
	CBC = 2,
	OFB = 3,
	XTS = 4,
	CBC_MAC = 5,
	CMAC = 6,
	GCM = 7,
	CCM = 8,
};

enum SCE_OP_MODE {
	SCE_ENC = 0,
	SCE_DEC = 1,
};

#endif
