#ifndef __LIB_SM2_PHYTIUM_H__
#define __LIB_SM2_PHYTIUM_H__

struct sm2_info {
	uint32_t type;
	uint32_t src_len;
	uint32_t dst_len;
	uint8_t *src;
	uint8_t *dst;
	uint8_t *key;
};

/*API*/
int phytium_scto_sm2_sign(uint8_t *e, const uint32_t e_len, uint8_t *priv_key,
			  const uint32_t priv_key_len, uint8_t *der_code_out,
			  uint32_t *der_code_out_len);
int phytium_scto_sm2_verify(uint8_t *e, const uint32_t e_len, uint8_t *pub_key,
			    const uint32_t pub_key_len, uint8_t *sign_result,
			    uint32_t sign_result_len);
int phytium_scto_sm2_dec(uint8_t *src, const uint32_t src_len,
			 uint8_t *priv_key, const uint32_t priv_key_len,
			 uint8_t *dst, uint32_t *dst_len);
int phytium_scto_sm2_enc(uint8_t *src, const uint32_t src_len, uint8_t *pub_key,
			 const uint32_t pub_key_len, uint8_t *dst,
			 uint32_t *dst_len);

int phytium_scto_sm2_genkey(uint8_t prikey[32], uint8_t pubkey[65]);

int phytium_scto_sm2_pubkey(const uint8_t prikey[32], uint8_t pubkey[65]);

int phytium_scto_sm2_exchangekey(uint8_t role, uint8_t *a_prikey,
				 uint8_t *b_pubkey, uint8_t *a_tmp_prikey,
				 uint8_t *a_tmp_pubkey, uint8_t *b_tmp_pubkey,
				 uint8_t *ZA, uint8_t *ZB, uint32_t key_length,
				 uint8_t *key_data, uint8_t *S1, uint8_t *SA);

void scto_sm2signature_encode(uint8_t *input, uint8_t *sig, uint32_t *sig_len);

int scto_sm2signature_decode(uint8_t *sig, uint32_t sig_len, uint8_t *out);

void scto_sm2encrypt_encode(uint8_t *input, uint32_t inlen, uint8_t *output,
			    uint32_t *outlen);

int scto_sm2decrypt_decode(uint8_t *input, uint32_t inlen, uint8_t *output,
			   uint32_t *outlen);
#endif
