#ifndef _LIB_SM4_PHYTIUM_H_
#define _LIB_SM4_PHYTIUM_H_

/*register offset*/
#define SKE_MODE_OFFSET           (9)
#define SKE_CRYPTO_OFFSET         (8)
#define SKE_UPDATE_IV_OFFSET      (18)
#define SKE_ERR_CFG_OFFSET        (8)

#define SM4_BLOCK_BYTE_LEN  (16)
#define SM4_BLOCK_WORD_LEN  (4)
#define SM4_KEY_BYTE_LEN    (16)
#define SM4_KEY_WORD_LEN    (4)

typedef enum {
	SM4_MODE_ECB = 0,
	SM4_MODE_CBC,
	SM4_MODE_CFB,
	SM4_MODE_OFB,
	SM4_MODE_CTR,
} sm4_mode_e;

typedef enum {
	SM4_CRYPTO_ENCRYPT = 0,
	SM4_CRYPTO_DECRYPT,
} sm4_crypto_e;

int phytium_scto_sm4_init(int *desc_id, uint32_t mode, uint32_t cryptomode, const uint8_t *key, const uint8_t*iv);
int phytium_scto_sm4_update(int desc_id, const uint8_t *in, uint32_t len, uint8_t *out);

#endif

