#ifndef _SCE_TEST_HASH_H_
#define _SCE_TEST_HASH_H_

typedef struct {
	const char *plaintext;
	const char *digest;
	int psize;
	int dsize;
	int alg;
	int mode;
} hash_testvec_t;

typedef struct {
	const char *key;
	const char *plaintext;
	const char *digest;
	uint32_t ksize;
	uint32_t psize;
	uint32_t dsize;
	int alg;
	int mode;
} hmac_testvec_t;

int hash_test(uint32_t hash_dma_mode, int src_link_num);

int hmac_test(uint32_t hash_dma_mode, int src_link_num);

int hash_speed_test(int queue_num, long num, int alg, int mode, int size,
		    uint32_t hash_dma_mode, int src_link_num);

int hash_delay_test(int alg, int mode, int size, uint64_t hash_dma_mode,
		    int src_link_num);

int hash_sca_speed_test(int queue_num, long num, int hash_alg, int hash_mode,
			int sca_alg, int sca_mode, int op_mode, int size);

#endif
