#ifndef _SCE_TEST_SKE_H_
#define _SCE_TEST_SKE_H_

typedef struct {
	char *key;
	char *iv;
	char *ptext;
	char *assoc;
	char *ctext;
	int klen;
	int plen;
	int clen;
	int alen;
	int ilen;
	int block_size;
	int alg;
	int mode;
} gcm_testvec_t;

typedef struct {
	char *key;
	char *iv;
	char *ptext;
	char *assoc;
	char *ctext;
	int klen;
	int plen;
	int clen;
	int alen;
	int ilen;
	int block_size;
	int alg;
	int mode;
} ccm_testvec_t;

typedef struct {
	uint8_t qlen : 3;
	uint8_t tlen : 3;
	uint8_t aad : 1;
	uint8_t reserved : 1;
} __attribute__((packed)) ccm_flag_t;

typedef struct {
	const char *key;
	const char *ptext;
	const char *ctext;
	const char *iv;
	unsigned int klen;
	unsigned int len;
	unsigned int ilen;
	unsigned int taglen;
	int alg;
	int mode;
} ske_testvec_t;

extern ske_testvec_t ske_tv_template[];
extern gcm_testvec_t gcm_tv_template[];
extern ccm_testvec_t ccm_tv_template[];

int sca_test(int dma_mode, int src_link_num, int dst_link_num);
int gcm_test(int dma_mode, int src_link_num, int dst_link_num);
int ccm_test(int dma_mode, int src_link_num, int dst_link_num);
int sca_mac_test(int dma_mode, int src_link_num, int dst_link_num);
int sca_speed_test(int queue_num, long num, int alg, int mode, int op_mode,
		   int size, int dma_mode, int src_link_num, int dst_link_num);
int sca_delay_test(int alg, int mode, int op_mode, int size, int dma_mode,
		   int src_link_num, int dst_link_num);
int sca_tv_template_count(void);
int gcm_tv_template_count(void);
int ccm_tv_template_count(void);

#endif
