/* SPDX-License-Identifier: GPL-2.0 */
#ifndef __SM4_SOFTWARE_H__
#define __SM4_SOFTWARE_H__



struct sm4_context {
	u32 encsk[32];  /* SM4 subkeys */
	u32 decsk[32];  /* SM4 subkeys */
} ;

struct sm4_func {
	void (*sm4_setkey_enc)(struct sm4_context *ctx, const u8 key[16]);
	void (*sm4_setkey_dec)(struct sm4_context *ctx, const u8 key[16]);
	void (*sm4_crypt_ecb_enc)(struct sm4_context *ctx, size_t length, u8 iv[16], const u8 *input, u8 *output);
	void (*sm4_crypt_ecb_dec)(struct sm4_context *ctx, size_t length, u8 iv[16], const u8 *input, u8 *output);
	void (*sm4_crypt_cbc_enc)(struct sm4_context *ctx, size_t length, u8 iv[16],
	                          const u8 *input, u8 *output);
	void (*sm4_crypt_cbc_dec)(struct sm4_context *ctx, size_t length, u8 iv[16],
	                          const u8 *input, u8 *output);
	void (*sm4_crypt_ctr)(struct sm4_context *ctx, size_t length, u8 ctr[16],
	                      const u8 *input, u8 *output);
};

void sm4_func_alloc(struct sm4_func *func);
#endif
