#ifndef _SM2_TEST_H___
#define _SM2_TEST_H___

struct pacc_sm3_context {
	uint64_t total; /* number of bytes processed */
	uint32_t state[8]; /* intermediate digest state */
	uint8_t buffer[64]; /* data block being processed */
} __attribute__((aligned(64)));

typedef struct {
	unsigned char *Apubkey;
	unsigned char *Aprikey;
	unsigned char *apubkey;
	unsigned char *aprikey;
	unsigned char *Bpubkey;
	unsigned char *Bprikey;
	unsigned char *bpubkey;
	unsigned char *bprikey;
	unsigned char *IDA;
	unsigned char *IDB;
	unsigned char *ZA;
	unsigned char *ZB;
	unsigned char *c;
	unsigned char *S1;
	unsigned char *SA;
	int IDA_len;
	int IDB_len;
	int c_len;
	int algo;
} sm2_exchange_key_testvec_t;

static sm2_exchange_key_testvec_t sm2_exchange_key_tv_template[] = {
	{
		/* From gmssl */
		.IDA_len = 16,
		.IDB_len = 16,
		.c_len = 128,
		.algo = 0,
		.Apubkey =
			"\xb6\x16\x0e\x70\x75\x19\x95\x46\x38\x8d\x76\x2f\xb4\xd7"
			"\x8d\x5c\xc6\x82\x32\x15\x8e\xb4\xaa\x64\x1e\x6e\x40\xa2\xca"
			"\xc3\x32\x68\xce\x38\xb5\xe5\xbe\xd5\x5d\xcc\xa4\xc4\xc8\xfb"
			"\xa1\xa1\x87\xbc\x94\x6a\x7a\x87\xd6\xfd\xb7\xd1\x46\xe8\x47"
			"\x0e\x75\x74\xb2\x05",
		.Aprikey =
			"\x5d\xfb\xc2\x8c\xe0\x8f\x54\x13\xf0\x56\xf4\x26\xd5\x2b\x76"
			"\xce\xdf\x45\xf2\xfb\xc4\x76\x22\xfd\x03\x0e\x76\xb3\xbf\xdf"
			"\x76\xb5",
		.apubkey =
			"\x61\x24\xb7\x95\xf2\xc4\x5f\xa9\xe6\x04\x25\xe0\xbe\x34"
			"\xfa\x3b\x4b\x1c\x9e\xe2\x9b\x75\xb6\xa7\x2a\xef\xc7\xaa\xd5"
			"\xc3\x25\x28\xee\x0a\x93\x33\xa6\x3b\xfd\x3b\xef\x32\xff\x33"
			"\x4d\x9f\x85\xbb\x99\xd5\x3e\x99\xc1\xf2\xfc\x17\xb5\x07\x73"
			"\x64\xed\x63\x2f\x64",
		.aprikey =
			"\x83\x13\x7c\x40\x0b\xef\xf2\x4d\x1e\x8c\x02\xb5\x5b\xd1\xb1"
			"\x69\x01\x74\x1d\x79\x5d\x70\x02\x25\x6a\xd3\xaf\x3c\x8a\x43"
			"\xe4\x6e",
		.Bpubkey =
			"\x02\x36\x14\xa8\x8e\x5d\x22\xb2\x39\x83\x7c\x8b\x8c\x5d"
			"\xf9\xe2\xa0\xc5\xe2\x90\x2d\x86\xd5\x93\xb5\xb8\x44\x26\xd3"
			"\x6e\xed\x7b\xcc\xcc\x31\xdb\x97\x34\xad\xe2\x64\xf0\x18\x9b"
			"\xd1\x6e\xc2\x18\xbe\xf7\x26\x1f\xdb\x6b\x58\x5c\x4c\x6c\x9c"
			"\x14\x23\xb4\x10\xca",
		.Bprikey =
			"\x53\xae\x30\x07\xc1\x45\x36\xa4\x18\x75\x68\x95\xc2\xd7\x2a"
			"\xce\xd1\xc6\x7a\x46\xc9\xde\x98\x15\xbe\x9e\xdb\x89\x43\x65"
			"\x6e\xce",
		.bpubkey =
			"\x8d\xdf\x78\x64\x1f\xa4\x8d\xf6\xea\x84\xd5\x7a\x2e\x96"
			"\x4b\xa1\x13\x54\xa1\xa9\x3b\x94\x09\x61\xcd\x5d\xf8\x3b\x89"
			"\x1c\xa3\x6d\xd6\xdb\x53\xcb\x59\xd6\xa2\x6d\xbd\xe0\xcf\xd9"
			"\xe0\xb6\x56\x33\x2e\x5d\xf0\xeb\x57\x6a\xa7\x7b\xae\x2e\x38"
			"\xba\x34\x0a\x7d\xed",
		.bprikey =
			"\x48\x58\x9b\x7f\x55\xd8\xa7\xf8\x0e\x6f\x24\x5d\x68\x24\x33"
			"\x72\xaa\x9f\x02\x27\x42\xf2\xea\x8f\x16\x4a\x34\x24\x2f\x6c"
			"\x2f\xfa",
		.IDA = "SM2 TEST ID A!!!",
		.IDB = "SM2 TEST ID B!!!",
		.ZA = "\x7a\x1d\xd2\x04\x0d\xbd\xbc\xba\xae\xa0\xce\xe3\x42\x4a\x92\xfb"
		      "\x3a\xd2\x29\x76\x45\xfa\xaa\xe9\x51\x72\xa8\x2f\x83\xb4\x8d\x6d",
		.ZB = "\x66\x31\x6d\x22\x9e\x63\x5c\x4e\x65\x2f\xde\x44\xf7\xae\x1a\xab"
		      "\xed\x5b\x7b\x7c\xb7\x59\x1b\x7b\xab\x5b\x0a\x47\xb1\xf7\x8d\x11",
		.c = "\xfe\x8f\x8e\xe6\x9b\x23\x50\xd3\x67\xe8\x98\x3b\xd3\xd3\x68\x7b"
		     "\xc7\x95\xec\x22\x62\xd8\x80\x07\x21\xe8\x75\x83\x9b\x3f\xcf\x9b"
		     "\x38\xa6\x43\xc0\xfa\x8f\x99\xf7\x9a\x51\x1e\xf5\x5c\xf4\x38\xc1"
		     "\xc0\x05\xf4\x32\x8a\xf8\xf7\xa8\xad\xb8\xd0\x19\x8a\x1c\x06\xe0"
		     "\x69\xe2\x56\xf8\xac\x18\x2b\x53\x7d\x42\x51\x87\x21\x1a\x82\x34"
		     "\xba\x5c\x41\xb6\x55\x4f\xe8\x9f\xaf\x50\x1c\x84\x4f\x5c\xf0\x16"
		     "\xac\x83\x2b\x36\x9c\xf2\x56\x1b\x19\x56\xf6\xf4\xb0\x36\xaf\x63"
		     "\x33\x01\x15\x0e\xf7\x53\x75\x87\x33\xb2\x17\x5c\x10\x88\x73\x73",
		.S1 = "\x96\x02\x1c\xd8\x28\x5f\x22\x29\xcf\xe4\x78\xdc\xf1\x02\x04\xad"
		      "\xc8\x7b\x50\xae\x83\x46\x38\x66\xc0\x0c\x27\xfa\xe8\x5d\x2a\x66",
		.SA = "\xfa\x28\x17\xc6\xfc\x83\xc8\x33\x3c\x49\x13\xe4\x67\x05\x6e\x5e"
		      "\xbd\x2f\x2b\xfa\xe9\xda\xc5\x55\x43\x05\x8c\x82\x86\x98\x64\x6d",
	},

	{
		/* From gmssl */
		.IDA_len = 16,
		.IDB_len = 16,
		.c_len = 128,
		.algo = 0,
		.Apubkey =
			"\xa0\xf8\xad\xe8\xce\x7c\x81\x05\xd0\xc9\x1c\x02\x58\x60"
			"\xc4\xe7\x2a\xfe\x21\x7a\xe6\xb6\x2c\xc8\x64\x73\x9c\x18\x9f"
			"\xbe\x2f\x33\x99\x0d\xe6\xf1\x0e\xac\x23\x82\x73\xd5\x98\x09"
			"\x39\x52\xe1\xe0\xbd\x16\xaf\x90\xfc\xc1\x58\x35\x80\x4f\xe8"
			"\xfd\xca\xf8\x2a\x5a",
		.Aprikey =
			"\x60\x78\x03\x7f\x3e\xaf\x14\xc0\xda\xbe\x58\x26\x80\xa4\x52"
			"\x94\x2a\xe5\x84\x5e\x6c\x4f\xe5\x33\xe2\x83\x22\xe9\xfc\x69"
			"\x42\x46",
		.apubkey =
			"\x47\x29\x36\x5b\x07\x39\xee\xb9\xc8\x7a\xa4\x39\x0c\xed"
			"\x01\xf5\x24\x9f\x93\x6d\x88\xe2\x4e\x9c\xf7\xf8\xb4\x67\x88"
			"\x5f\x9b\xab\x49\xe6\x9c\xe1\xf8\xd6\xa6\xad\xcf\x21\xfa\x0c"
			"\x86\x41\xce\x82\xc1\x11\xbd\x0f\xfa\xeb\x0d\xf0\x4a\x71\x3d"
			"\x3b\x01\x92\x33\x37",
		.aprikey =
			"\x37\xa4\xb0\xf9\x9e\xa8\x60\x42\x4e\x40\x14\x25\x6b\x16\x22"
			"\xcb\x53\xaa\xc2\xbe\xfc\x1f\xad\x56\x17\xac\x10\x81\x27\x00"
			"\x06\xfc",
		.Bpubkey =
			"\x98\xcb\x64\xf2\x0f\x6f\x72\x59\xbd\xd5\xa4\xc4\x75\x21"
			"\xdb\x60\x09\xe9\xc9\xaf\x41\x5f\xaa\xde\xcb\xca\xa3\x36\x96"
			"\x0d\xae\x57\x03\x1f\x0c\x26\x58\x08\x07\x4d\xd0\xa0\x0b\x74"
			"\xcf\x9e\x26\xf0\xa7\xf1\x8f\xbf\x46\x69\x12\x21\xda\xf0\xb4"
			"\xa0\x86\x5a\x30\xaa",
		.Bprikey =
			"\x73\xa8\x0d\xee\xd0\x94\x19\xbf\x84\xd4\xd0\xf7\x82\x14\x21"
			"\x9c\x8b\x66\xb2\xdd\xf8\x6b\x87\x1d\xa3\xd8\x3e\xc4\xd2\x15"
			"\xa3\x0f",
		.bpubkey =
			"\x91\x01\xc0\x2c\x18\x2a\x69\xfb\xb9\x8a\xf2\x14\x21\x21"
			"\x9e\x25\xea\x21\x6b\xd3\x9a\x91\x0f\xb8\x52\xdf\xc4\xae\x72"
			"\xe5\x7e\xa9\x4f\xb8\xb6\x44\xaf\x50\xa9\x45\x5f\x02\xe8\x42"
			"\x1e\x7c\x66\x87\xd2\x47\x84\x52\xc8\x5c\x09\x20\x1a\x3a\x52"
			"\xf5\x52\xf1\x35\xb4",
		.bprikey =
			"\xc3\x5f\xe3\x1c\x00\xe4\x77\x37\xe4\xec\xc7\x5c\x5d\xb1\xb2"
			"\x12\xb3\xf8\xbc\x9b\x03\x4e\xee\x09\xa2\x83\xb6\x18\xd8\xf4"
			"\xfd\xeb",
		.IDA = "SM2 TEST ID A!!!",
		.IDB = "SM2 TEST ID B!!!",
		.ZA = "\x64\x01\x39\x0b\xaa\x1e\x8b\xe0\x8c\xb4\xb6\x8f\x52\x38\x29\x8e"
		      "\xff\xd1\x16\x1d\x83\x82\x4e\x12\x05\x01\x61\x99\x99\x60\xde\x05",
		.ZB = "\x25\x11\x2b\x03\xcd\xa1\xa7\xde\xb9\x1c\x40\x2b\x39\x4b\x20\xa4"
		      "\xc5\x72\xc3\xcb\xc3\xb6\x74\x9c\x13\x73\xda\xaf\xbb\x9e\x99\x4c",
		.c = "\x95\x75\x01\x4e\x0c\x88\x33\xf7\xe5\xe4\xdd\x2e\xa3\x42\x53\x80"
		     "\xad\x76\xb2\xe0\x4b\x05\x07\xfd\xf8\x4d\xab\x82\x91\xd2\xc1\x1a"
		     "\x5a\x20\x96\x5d\x9b\x06\x68\xcb\x95\x14\x86\xad\xe7\xbd\xe9\x88"
		     "\x8a\xd6\x40\x21\xd7\x24\x91\xb1\x58\xc3\x0f\xb2\xca\x80\xac\x81"
		     "\xb0\x15\x52\x48\x47\x58\xcc\x06\x12\xf1\xf2\xc3\x7a\x4c\x0b\x4d"
		     "\xa9\x7f\xa8\xaf\xee\xba\xff\x19\x46\x31\xf5\xbe\xad\xe9\x79\x8f"
		     "\x0e\xba\x97\xcd\xdb\x1f\xa2\xca\xb1\x53\x76\x9e\xa6\xf1\x53\xcb"
		     "\x2f\x70\x17\xef\x36\x57\x7b\x47\xb7\x8e\x90\x17\xca\x07\xbd\x5f",
		.S1 = "\x4f\x0f\x95\x69\xc7\xc3\xe4\x85\xb1\x81\x72\x85\x69\x8c\xac\x56"
		      "\xaa\x0d\xc0\xd9\xa1\x92\xc3\x1b\xb1\x02\xcd\x21\x0e\x1f\x39\x01",
		.SA = "\xb9\x86\xf7\xff\xef\x87\x71\x23\x2b\xc2\x58\x51\x97\xed\x8c\x11"
		      "\x0b\x58\xc1\xc7\x87\xeb\xf2\x5a\xcf\xc1\x5c\x8c\xaa\x47\x1a\x67",
	}
};
#endif
