/* SPDX-License-Identifier: GPL-2.0-or-later */
#ifndef __AEAD_H__
#define __AEAD_H__

#define AEAD_INIT_128 0xFFFFFFFFFFFFFFFFull
#define CCM_BLOCK_BYTE_LEN 1
#define CCM_DIGEST_BYTE_LEN 16
#define CCM_IV_BYTE_LEN 16

struct ccm_flag {
	uint8_t qlen : 3;
	uint8_t tlen : 3;
	uint8_t aad : 1;
	uint8_t reserved : 1;
} __packed;

struct ccm_alg_context {
	u8 alg;
	u8 mode;
	u8 block_size;
	u8 block_shift;
	u8 iv_size;
	u8 key_len;
	u16 key_len_flag;
	u64 key_ioaddr;
	//    u64 aad0_ioaddr;
	//    u64 cbcmac0_ioaddr;
	//    u64 temp3_ioaddr;
	//    u64 ecb_key_ioaddr;
	u8 key[64];
	//    u8 aad0[16];
	//    u8 cbcmac0[16];
	//    u8 temp3[16].
	//    u8 ecb_key[64];
} __packed;

struct cipher_cmd {
	u8 algo;
	u8 mode;
	u8 iv_load;
	u8 key_len_flag;
	u8 op_mode;
	u8 is_last_proc;
	u8 dst_src_addr_type;
	u8 reserved;
	u32 mac_tlen;
	u32 src_len;
	u64 src_ioaddr;
	u64 dst_ioaddr;
	u64 key_ioaddr;
	u64 iv_ioaddr;
} __packed;

struct ccm_session_context {
	u8 iv[CACHE_LINE_SIZE];
	u8 pad[CACHE_LINE_SIZE];
	u8 tag[CACHE_LINE_SIZE];
	u8 cbcmac_zero[CACHE_LINE_SIZE];
	u8 cbcmac_zero2[CACHE_LINE_SIZE];
	u8 cbcmac_result[CACHE_LINE_SIZE];
	u8 ecb_result[CACHE_LINE_SIZE];
	//u32 cur_aad_len;
	struct cipher_cmd ccm_cmd;
	struct link_list_item src_list_buf[MAX_LINKS + 2];
	struct link_list_item dst_list_buf[MAX_LINKS + 2];
} __packed;

int sce_ccm_algs_register(void);
void sce_ccm_algs_unregister(void);

#endif
