/* SPDX-License-Identifier: GPL-2.0-or-later */
#ifndef __AEAD_GCM_H__
#define __AEAD_GCM_H__
#include "ccm.h"
#define AEAD_INIT_128 0xFFFFFFFFFFFFFFFFull
#define GCM_BLOCK_BYTE_LEN 1
#define GCM_IV_BYTE_LEN 12

#define GCM_DIGEST_BYTE_LEN (16)

struct gcm_flag {
	uint8_t qlen : 3;
	uint8_t tlen : 3;
	uint8_t aad : 1;
	uint8_t reserved : 1;
} __packed;

struct gcm_alg_context {
	u8 alg;
	u8 mode;
	u8 block_size;
	u8 block_shift;
	u8 iv_size;
	u8 key_len;
	u16 key_len_flag;
	u64 key_ioaddr;
	//    u64 aad0_ioaddr;
	//    u64 cbcmac0_ioaddr;
	//    u64 temp3_ioaddr;
	//    u64 ecb_key_ioaddr;
	u8 key[64];
	//    u8 aad0[16];
	//    u8 cbcmac0[16];
	//    u8 temp3[16].
	//    u8 ecb_key[64];
} __packed;

struct gcm_session_context {
	u8 iv[CACHE_LINE_SIZE];
	u8 ctr_iv[CACHE_LINE_SIZE];
	u8 pad[CACHE_LINE_SIZE];
	u8 tag[CACHE_LINE_SIZE];
	u8 ghash_zero[CACHE_LINE_SIZE];
	u8 ghash_key[CACHE_LINE_SIZE];
	u8 ghash_result[CACHE_LINE_SIZE];
	u8 ecb_result[CACHE_LINE_SIZE];
	//u32 cur_aad_len;//link list要求对齐
	struct cipher_cmd gcm_cmd;
	struct link_list_item src_list_buf[MAX_LINKS + 2];
	struct link_list_item dst_list_buf[MAX_LINKS + 2];
} __packed;

int sce_gcm_algs_register(void);
void sce_gcm_algs_unregister(void);

#endif
