/* SPDX-License-Identifier: GPL-2.0-or-later */
#ifndef __MAC_H__
#define __MAC_H__

#define MAC_BUFFER_SIZE 384
#define MAC_BLOCK_BYTE_LEN 16

#define CMAC_DIGEST_BYTE_LEN 16
#define CBC_MAC_DIGEST_BYTE_LEN 16
struct mac_session_context {
	u8 buffer[16]; /* data block being processed */
	u8 state[128]; /* intermediate digest state */
	struct link_list_item list_buf[MAX_LINKS + 2]; //+2
	u64 state_ioaddr;
	u64 buffer_ioaddr;
	u64 list_buf_ioaddr;
	union {
		u64 list_data[3];
		struct {
			u64 is_first_req;
			u64 size;
			u64 addr;
		};
	};
	union {
		u64 data[3];
		struct {
			u64 total; /* number of bytes processed */
			u64 buffer_data_len;
			u64 mac_flag;
		};
	};
} __packed;

struct mac_alg_context {
	u8 alg;
	u8 mode;
	u8 block_size;
	u8 block_shift;
	u8 digest_size;
	u16 key_len_flag;
	u32 key_len;
	u64 key_ioaddr;
	u8 key[128];
} __packed;

int sce_mac_algs_register(void);
void sce_mac_algs_unregister(void);

#endif
