/* SPDX-License-Identifier: GPL-2.0 */
#ifndef __PHYTIUM_SCTO_H__
#define __PHYTIUM_SCTO_H__

#include <crypto/hash.h>
#include <crypto/akcipher.h>
#include <linux/ioctl.h>
#include "sm2_phytium.h"

#define MAGIC_NUM 'p'
#define SCTO_SM2 _IO(MAGIC_NUM, 2)

struct trng_reg {
	u32 cr;
	u32 rtcr;
	u32 sr;
	u32 dr;
};

struct scto_dev {
	void __iomem *regs;
	struct trng_reg *trng_reg;
	struct pke_reg *pke_reg[4];
	struct mutex pke_lock;
	struct phytium_sm2_queue sm2_queue[NR_CPUS];
};

enum {
	ALG_SM3 = 0x20200730,
	ALG_SM4,
	ALG_SM2_SIGN,
	ALG_SM2_VERIFY,
	ALG_SM2_ENC,
	ALG_SM2_DEC
};

int scto_device_probe(void);
void scto_device_remove(void);
#endif
