/* SPDX-License-Identifier: GPL-2.0 */
#ifndef _SMX_H_
#define _SMX_H_

#define SM2_TEST

//0-user space mode; 1-kernel space mode
#define SCTO_KERNEL_MODE (1)

static inline u32 swap32(u32 val)
{
	__asm__("rev %w[dst], %w[src]" : [dst] "=r"(val) : [src] "r"(val));
	return val;
}

#define GET_UINT32_BE(n, b, i) ((n) = swap32(*((u32 *)&(b)[(i)])))


#define PUT_UINT32_BE(n, b, i) (*((u32 *)&(b)[(i)]) = swap32((n)))


static inline void smx_reverse_word(const void *in, void *out, u32 wordlen)
{
	u32 i;
	const u32 *input = in;
	u32 *output = out;

	for (i = 0; i < wordlen; i++)
		output[i] = swap32(input[i]);
}

static inline void smx_dma_reverse_word(const void *in, void *out, u32 wordlen)
{
	u32 i, j, tmp;
	const u32 *input = in;
	u32 *output = out;

	for (i = 0; i < wordlen; i += 4) {
		for (j = 0; j < 2; j++) {
			tmp = input[i + j];
			output[i + j] = swap32(input[i + 0x3 - j]);
			output[i + 0x3 - j] = swap32(tmp);
		}
	}
}
#endif
