#ifndef _MK_TEST_COMMON_H_
#define _MK_TEST_COMMON_H_

enum {
    TEST_OP_MODE_CIPHER = 1,
    TEST_OP_MODE_AEAD = 2,
    TEST_OP_MODE_HASH = 3,
    TEST_OP_MODE_HMAC = 4,
};
struct sce_akcipher_testvec {
	const unsigned char *key;
	const unsigned char *params;
	const unsigned char *m;
	const unsigned char *c;
	unsigned int key_len;
	unsigned int param_len;
	unsigned int m_size;
	unsigned int c_size;
	bool public_key_vec;
	bool siggen_sigver_test;
//	enum OID algo;
};
#define get_driver_name(tfm_type, tfm)                                         \
    crypto_tfm_alg_driver_name(tfm_type##_tfm(tfm))

int akcipher_test(char *alg, const struct sce_akcipher_testvec *vecs);

void print_buf(u8 *name, u8 *buf, u32 len);

void ahash_dgst_test(char *alg, const u8 *key, unsigned int klen,
                     const u8 *data, unsigned int len, u8 *out);

void ahash_finup_test(char *alg, const u8 *key, unsigned int klen,
                      const u8 *data, unsigned int len, u8 *out);

void ahash_step_test(char *alg, const u8 *key, unsigned int klen,
                     const u8 *data, unsigned int len, u8 *out);


void skcipher_test(char *alg, int enc, const u8 *key, int klen, u8 *iv,
                   const u8 *data, unsigned int len, u8 *out);

void skcipher_step_test(char *alg, int enc, const u8 *key, int klen, u8 *iv,
                        const u8 *data, unsigned int len, u8 *out);

void aead_test(char *alg, int enc, const u8 *key, int klen, u8 *iv,
               const u8 *data, unsigned int len, unsigned int aad_len, u8 *out, unsigned int out_len);

void sce_get_alg_name(char *alg_name, char *alg, char *mode);

#endif
