#ifndef __HASH_TEST_H_
#define __HASH_TEST_H_

typedef struct {
    const char *plaintext;
    const char *digest;
    int psize;
    int dsize;
    int alg;
    int mode;
} hash_testvec_t;

typedef struct {
    const char *key;
    const char *plaintext;
    const char *digest;
    uint32_t ksize;
    uint32_t psize;
    uint32_t dsize;
    int alg;
    int mode;
} hmac_testvec_t;

enum SCE_HASH_ALGO_TYPE {
    SCE_SHA1 = 0,
    SCE_SHA224 = 1,
    SCE_SHA256 = 2,
    SCE_SHA384 = 3,
    SCE_SHA512 = 4,
    SCE_MD5 = 5,
    SCE_MAC_DES = 6,
    SCE_MAC_DES3_EDE = 7,
    SCE_SM3 = 8,
    SCE_MAC_AES = 9,
    SCE_MAC_SM4 = 10,
};

enum SCE_HASH_ALGO_MODE {
    SCE_NORMAL = 0,
    SCE_HMAC = 1,
};

void hmac_test(char *alg, char *mode, u32 klen, u32 slen, u32 elen);

void hash_test(char *alg, char *mode, u32 klen, u32 slen, u32 elen);

#endif
