#ifndef __SCA_TEST_H_
#define __SCA_TEST_H_

typedef struct {
    const char *key;
    const char *ptext;
    const char *ctext;
    const char *assoc;
    const char *iv;
    unsigned int klen;
    unsigned int len;
    unsigned int ilen;
    unsigned int aadlen;
    unsigned int clen;
    int alg;
    int mode;
} ske_testvec_t;

enum SCE_SCA_ALGO_TYPE {
    SCE_AES_128 = 0x00,
    SCE_AES_192 = 0x10,
    SCE_AES_256 = 0x20,
    SCE_DES = 0x1,
    SCE_TDES = 0x2,
    SCE_SM4 = 0x4,
};

enum SCE_SCA_ALGO_MODE {
    ECB = 0,
    CTR = 1,
    CBC = 2,
    OFB = 3,
    XTS = 4,
    CBC_MAC = 5,
    CMAC = 6,
    GCM = 7,
    CCM = 8
};

// 根据mode 获取mode
u32 get_alg_mode(char *mode);

void cipher_test(char *alg, char *mode, u32 klen, u32 slen, u32 elen);

void aead_check_test(char *alg, char *mode, u32 klen, u32 slen, u32 elen);

#endif
